//#include "stdafx.h"
#include "common.h"

using namespace System;

namespace cmmn {

	int n_comp, NCatVar;
	int * nCatPerVar;
	int TCat;
	int NCases, MNVar;
	int ** X;
	double *** G, *** W, ** Lambda, *** Gw, ** Z, ** C, ** S;
	int * nweight;
	int ck_rank;

	int NGrp;
	char * GrpID;
	int * Nmem;
	double ** F;
	double *** Fk;
	double ** Gmeans;

	double ** xstar;

	double *** y;
	double ** Gy;

    double * XCoord, * YCoord;


	void CalcWeights( StreamWriter ^ fout, double ** G, int ncases, int p, int & nweight, double ** W, double * Lambda, double ** Gw ){
		double * f = new double[p];
		for (int i = 0; i < p; i++){
			f[i] = 0.0;
			for (int j = 0; j < ncases; j++)
				f[i] += G[j][i];
		}
		double ** G_m;
		G_m = new double*[ncases];
		for (int i = 0; i < ncases; i++){
			G_m[i] = new double[p];
			for (int j = 0; j < p; j++)
				G_m[i][j] = G[i][j] - f[j] / double(ncases);
		}

		myMat DGpGD(p, p);
		for (int i = 0; i < p; i++)
			for (int j = i; j < p; j++){
				double v = 0.0;
				for (int h = 0; h < ncases; h++)
					v += G_m[h][i] * G_m[h][j];
				DGpGD[i][j] = DGpGD[j][i] = v;
			}

		QL_decom ql;
		myMat aa(p, p), EigenVec(p, p), EigenVal(p, 1);
		int n_eigen;
		aa = DGpGD;
		ql.DoQL( aa, EigenVec, EigenVal, n_eigen );
		nweight = n_eigen;
		for (int i = 0; i < p; i++)
			Lambda[i] = EigenVal[i][0];

		fout->WriteLine("Lambda...");
		for (int i = 0; i < nweight; i++)
			fout->Write(Lambda[i].ToString()->PadLeft(20));
		fout->WriteLine();
		fout->WriteLine("Omega...");
		for (int i = 0; i < p; i++){
			if (i < nweight){
				for (int j = 0; j < p; j++)
					W[j][i] = EigenVec[j][i];
			}else{
				for (int j = 0; j < p; j++)
					W[j][i] = 0.0;
			}
		}

		for (int i = 0; i < ncases; i++){
			for (int j = 0; j < p; j++){
				if (j < nweight){
					double v = 0.0;
					for (int h = 0; h < p; h++)
						v += G_m[i][h] * W[h][j];
					Gw[i][j] = v;
				}else{
					Gw[i][j] = 0.0;
				}
			}
		}

		for (int j = 0; j < p; j++){
			for (int i = 0; i < nweight; i++)
				fout->Write(W[j][i].ToString("F3")->PadLeft(20));
			fout->WriteLine();
		}

		for (int i = 0; i < ncases; i++)
			delete [] G_m[i];
		delete [] G_m;
	}

}
